import argparse
import secrets
import base64

from openec2.db import get_session
from openec2.db.user import User

from sqlmodel import select


def main():
    parser = argparse.ArgumentParser()
    parser.add_argument("--name", type=str, required=True)
    args = parser.parse_args()

    secret_access_key = base64.b64encode(
        secrets.token_bytes(64),
    ).decode()

    db = next(get_session())
    access_key = base64.b64encode(
        secrets.token_bytes(32),
    ).decode()
    while True:
        if db.exec(select(User).where(User.access_key == access_key)).first() is None:
            break

        access_key = base64.b64encode(
            secrets.token_bytes(32),
        ).decode()

    db.add(
        User(
            name=args.name,
            access_key=access_key,
            secret_access_key=secret_access_key,
        )
    )
    db.commit()

    print(f"Access key: {access_key}")
    print(f"Secret access key: {secret_access_key}")


if __name__ == "__main__":
    main()
