from sqlmodel import SQLModel, Field


class AMI(SQLModel, table=True):
    # ID of the AMI
    id: str = Field(default=None, primary_key=True)

    # Description of the image
    description: str | None = None

    # Filename that got imported
    originalFilename: str

    # Was the image registered
    deregistered: bool = Field(default=False)

    # Owner of the image who created it
    owner_id: int = Field(foreign_key="user.id")
