from sqlmodel import select

from openec2.config import ConfigSingleton
from openec2.db import DatabaseDep
from openec2.db.instance import Instance
from openec2.db.image import AMI


def garbage_collect_image(image_id: str, db: DatabaseDep):
    instances = db.exec(select(Instance).where(Instance.imageId == image_id)).all()
    if instances:
        print("Instances sill using AMI. Not cleaning up")
        print(instances)
        return

    ami = db.exec(
        select(AMI).where(AMI.id == image_id, AMI.deregistered == True)
    ).first()
    if ami is not None:
        db.delete(ami)
        db.commit()
        image = ConfigSingleton.of().config.images / image_id
        image.unlink()
        print(f"Removing {image}")
